indexing
   title:       "RT_FM_95"
   cluster:     "timedate/sig [timedate/sig]";
   project:     "The Universal Time & Date UTDC";
   copyright:   "SIG Computer, 1995";
   author:      "Frieder Monninger";
   original:    22,Sep,95
   version:     1.0
   done_at:     "SIG Computer (info@eiffel.ru)";
   license:     "GNU Library GPL - see included readme file";
   extrnl_name: "rt_fm_95.e";

class RT_FM_95

   feature

      pout (para: ANY): STRING is

         local
            pb: BOOLEAN_REF
            pi: INTEGER_REF
            pr: REAL_REF
            ps: STRING
            pc: CHARACTER_REF
            i: INTEGER
            l_format, s_format: STRING 

         do

            -- boolean ? 
            pb ?= para;
            if pb /= void then
               if pb.item then 
                  Result := "true"
               else
                  Result := "false"
               end
            else
               -- character 
               pc ?= para;
               if pc /= void then
                  !!Result.make (1)
                  Result.put (pc.item, 1)
               else
                  -- integer ? 
                  pi ?= para;
                  if pi /= void then
                     Result := fmt.i2s ( format_i, pi.item)
                  else
                     -- real ?    
                     pr ?= para;
                     if pr /= void then
                        Result := fmt.r2s ( format_r, pr.item)
                     else

                        -- string ?  
                        ps ?= para;
                        if ps /= void then
                           Result := ps
                        else 
                           Result := "["
                           Result.append (obj.classname (para))
                           Result.append ("]%N");
                           Result.append (tout (para))
                        end
                     end
                  end
               end
            end
         end -- pout                 

      tout (para: ANY): STRING is

         local 
            i: INTEGER
            s: STRING

         do
            if para = void then
               Result := "void"
            else
               Result := ""
               from 
                  i := 1 
               until
                  i > obj.attribute_count (para)
               loop
                  Result.append (obj.attribute_name (para, i))
                  Result.append (": ")

                  inspect
                     obj.attribute_type (para, i)
                  when
                     'b' then 
                     if obj.boolean_value (para, i)  
                        then Result.append ("true")
                     else Result.append ("false")
                     end
                  when
                     'c' then
                     Result.extend (obj.character_value (para, i))
                  when
                     'i' then
                     Result.append (fmt.i2s (format_i, obj.integer_value (para, i)))
                  when
                     'r' then
                     Result.append (fmt.r2s (format_r, obj.real_value (para, i)))
                  when 
                     'p' then
                     Result.append ("POINTER")
                  when
                     'o' then
                     s ?= obj.object_value (para, i)
                     if s = void then
                        Result.append (obj.classname (obj.object_value (para, i)))
                     else
                        if s.count > 20 
                           then
                           Result.append (s.substring (1,20))
                           Result.append (" ...")
                        else
                           Result.append (s)
                        end
                     end
                  else
                  end
                  Result.append ("%N")
                  i := i + 1
               end -- loop      
            end -- if        
         end

   feature {NONE}

      format_i: STRING is ""
      format_r: STRING is ""

      fmt: FORMAT is

         once
            !!Result
         end

      obj: OBJECT_STRUCTURE is

         once
            !!Result
         end

      end -- class RT_FM_95       
